// Win32DlgOpenCV.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "Win32Dlgcommunity2013.h"

//t@C֘A
TCHAR szOpenFileName[MAX_PATH];
TCHAR szSaveFileName[MAX_PATH];

int openFileNameBox(HWND hWnd);      //GetOpenFileName֐p
int saveFileNameBox(HWND hWnd);      //GetSaveFileName֐p

//Rg[̒l擾p
TCHAR szBufEdit1[1024]; //GfBbg1͗p
TCHAR szBufEdit2[1024]; //GfBbg1͗p

BOOL bCheck1, bCheck2; //`FbN{bNXp

//R{{bNXp
LPCTSTR strItem[] = {
	TEXT("I1"),
	TEXT("I2"),
	TEXT("I3")
};

HWND hCombo;
UINT comNo;

//XC_[p
HWND hBar;
int Pos;	//ꂪʒu
TCHAR strBar[128];

/*----------------------------------------------
Rg[
-----------------------------------------------*/
void initialControls(HWND hDlg)
{
	InitCommonControls();

	//eLXg
	SetDlgItemText(hDlg, IDC_STATIC_TEXT1, "eLXg1");
	SetDlgItemText(hDlg, IDC_STATIC_TEXT2, "eLXg2");

	//GfBbg
	SetDlgItemText(hDlg, IDC_EDIT1, "0");
	SetDlgItemText(hDlg, IDC_EDIT2, "1");

	//`FbN{bNX
	SendMessage(GetDlgItem(hDlg, IDC_CHECK1), BM_SETCHECK, BST_CHECKED, 0);
	SendMessage(GetDlgItem(hDlg, IDC_CHECK2), BM_SETCHECK, BST_CHECKED, 0);

	//R{{bNX
	UINT i;
	WPARAM index;
	hCombo = GetDlgItem(hDlg, IDC_COMBO1);

	// R{{bNXɃf[^l߂Ă
	for (i = 0; i < 3; i++)
	{
		SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM)strItem[i]);
	}
	// EChEɂ͂߂ɕ\f[^w
	index = SendMessage(hCombo, CB_FINDSTRINGEXACT, -1, (LPARAM)TEXT("I1"));
	SendMessage(hCombo, CB_SETCURSEL, index, 0);

	//XC_[
	hBar = GetDlgItem(hDlg, IDC_SLIDER1);
	Pos = 10;

	SendMessage(hBar, TBM_SETRANGE, TRUE, MAKELPARAM(0, 100)); // Ww
	SendMessage(hBar, TBM_SETTICFREQ, 5, 0);   // ڐ̑
	SendMessage(hBar, TBM_SETPOS, TRUE, Pos);  // ʒu̐ݒ
	SendMessage(hBar, TBM_SETPAGESIZE, 0, 5); // NbN̈ړ
	sprintf(strBar, TEXT("%d "), Pos);
	SetWindowText(GetDlgItem(hDlg, IDC_STATIC_SL), (LPCTSTR)strBar);
}

/*----------------------------------------------
Rg[͎擾
-----------------------------------------------*/
void getControlValues(HWND hDlg)
{
	//GfBbg
	GetDlgItemText(hDlg, IDC_EDIT1, (LPTSTR)szBufEdit1, (int)sizeof(szBufEdit1));
	GetDlgItemText(hDlg, IDC_EDIT2, (LPTSTR)szBufEdit2, (int)sizeof(szBufEdit2));

	//`FbN{bNX
	bCheck1 = SendMessage(GetDlgItem(hDlg, IDC_CHECK1), BM_GETCHECK, 0, 0);
	bCheck2 = SendMessage(GetDlgItem(hDlg, IDC_CHECK2), BM_GETCHECK, 0, 0);

	//R{
	hCombo = GetDlgItem(hDlg, IDC_COMBO1);
	comNo = (UINT)SendMessage(hCombo, CB_GETCURSEL, 0, 0);

	//XC_[́AϐPos̒l
}

/*----------------------------------------------
_CAOvV[W
-----------------------------------------------*/
LRESULT CALLBACK DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int ret;

	int id = LOWORD(wParam);
	switch (message)
	{
	case WM_INITDIALOG:                // _CAȌ

		//Rg[̏
		initialControls(hDlg);

		return TRUE;

	case WM_HSCROLL:

		//XC_[̒l擾
		if (GetDlgItem(hBar, IDC_SLIDER1) == (HWND)lParam){
			hBar = GetDlgItem(hDlg, IDC_SLIDER1);
		}

		Pos = SendMessage(hBar, TBM_GETPOS, NULL, NULL); // ݂̒l̎擾

		sprintf(strBar, TEXT("%d "), Pos);
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_SL), (LPCTSTR)strBar);

		break;

	case WM_COMMAND:
		switch (id)
		{
		case ID_READ:
			ret = openFileNameBox(hDlg);
			break;

		case ID_SAVE:
			ret = saveFileNameBox(hDlg);
			break;

		case IDC_MYICON:                    // ~{^̏
			EndDialog(hDlg, IDOK);
			return TRUE;

		case ID_CLOSE:                   // {^̏
			EndDialog(hDlg, IDCANCEL);
			return TRUE;

		case ID_EXEC1:
			//MessageBox(hDlg, "1", "eXg", MB_OK);

			//Rg[̒l擾
			getControlValues(hDlg);
			break;

		case ID_EXEC2:
			MessageBox(hDlg, "2", "eXg", MB_OK);
			break;

		case ID_EXEC3:
			MessageBox(hDlg, "3", "eXg", MB_OK);
			break;

		case ID_EXEC4:
			MessageBox(hDlg, "4", "eXg", MB_OK);
			break;

		case ID_EXEC5:
			MessageBox(hDlg, "5", "eXg", MB_OK);
			break;

		default:
			break;
		}
		break;
	}
	return FALSE;
}

/*-----------------------------------
I[vt@C擾
-------------------------------------*/
int openFileNameBox(HWND hWnd)
{
	int i;
	OPENFILENAME ofn;

	memset(&ofn, 0, sizeof(OPENFILENAME));  // \̂̏

	ofn.lStructSize = sizeof(OPENFILENAME); //\̂̃TCY
	ofn.hwndOwner = hWnd;   //eEBhẼnh
	ofn.lpstrFilter = TEXT("All(*.*)\0*.*\0JPEGt@C(*.jpg)\0*.jpg\0PNGt@C(*.png)\0*.png\0\0"); //tB^[
	ofn.lpstrFile = szOpenFileName;     // tpXt@C
	ofn.nMaxFile = sizeof(szOpenFileName);      //tpXt@C̃TCY
	ofn.lpstrFileTitle = szOpenFileName;       //t@C
	ofn.nMaxFileTitle = sizeof(szOpenFileName);        //t@C̃TCY

	//t@Ĉݓ͋ | ǂݎ`FbN{bNX\Ȃ
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = TEXT("*");                    //ftHg̊gq
	ofn.lpstrTitle = TEXT("摜t@C̓Ǎ");      //^Cgo[ɕ\镶

	i = GetOpenFileName(&ofn);
	if (i == 0) {      //OK{^ĂȂ
		return 1;
	}

	MessageBox(hWnd, szOpenFileName, TEXT("debug"), MB_OK);

	return 0;
}

/*-----------------------------------
ۑt@C擾
-------------------------------------*/
int saveFileNameBox(HWND hWnd)
{
	int i;

	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(OPENFILENAME));  // \̂̏

	ofn.lStructSize = sizeof(OPENFILENAME); //\̂̃TCY
	ofn.hwndOwner = hWnd;   //eEBhẼnh
	ofn.lpstrFilter = TEXT("All(*.*)\0*.*\0JPEGt@C(*.jpg)\0*.jpg\0PNGt@C(*.png)\0*.png\0\0"); //tB^[
	ofn.lpstrFile = szSaveFileName;     // tpXt@C
	ofn.nMaxFile = sizeof(szSaveFileName);      //tpXt@C̃TCY
	ofn.lpstrFileTitle = szSaveFileName;       //t@C
	ofn.nMaxFileTitle = sizeof(szSaveFileName);        //t@C̃TCY
	ofn.Flags = OFN_OVERWRITEPROMPT;        // ㏑mF_CAO̕\
	ofn.lpstrDefExt = TEXT("*");    //ftHg̊gq
	ofn.lpstrTitle = TEXT("摜t@C̕ۑ");        //^Cgo[ɕ\镶

	i = GetSaveFileName(&ofn);        //t@Ctĕۑ_CAO{bNX
	if (i == 0) {      //OK{^ĂȂ
		return 1;
	}

	MessageBox(hWnd, szSaveFileName, TEXT("debug"), MB_OK);

	return 0;
}

/*-----------------------------------------------------
C֐
-------------------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN_DIALOG), NULL, (DLGPROC)DlgProc);
	return 0;
}

